{###############################################################################
# Dipesh-TxtEdit-32 Version 1.xx.xx                         Delphi 3 Quellcode #
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# E-Mail: dipesh@gmx.de                                                        #
# Homepage: http://members.tripod.de/dipesh4                                   #
################################################################################
# MAINCLD.PAS - TMainChildForm                                                 #
###############################################################################}

UNIT MainCld;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, FileCtrl, Menus, Clipbrd, Globals,
  RichEdit2;

Type
  TMainChildForm = class(TForm)
    StatusBar: TStatusBar;
    RichEdit: TRichEdit98;
    PopupMenu: TPopupMenu;
    PopupMenu_Ausschneiden: TMenuItem;
    PopupMenu_Kopieren: TMenuItem;
    PopupMenu_Einfuegen: TMenuItem;
    PopupMenu_Loeschen: TMenuItem;
    PopupMenu_N2: TMenuItem;
    PopupMenu_AllesMarkieren: TMenuItem;
    PopupMenu_N1: TMenuItem;
    PopupMenu_Rueckgaengig: TMenuItem;
    MainMenu: TMainMenu;
    MainMenu_Datei: TMenuItem;
    MainMenu_Datei_Neu: TMenuItem;
    MainMenu_Datei_Oeffnen: TMenuItem;
    MainMenu_Datei_Speichern: TMenuItem;
    MainMenu_Datei_SpeichernUnter: TMenuItem;
    MainMenu_Datei_Schliessen: TMenuItem;
    MainMenu_Datei_AlleSchliessen: TMenuItem;
    N5: TMenuItem;
    MainMenu_Datei_Drucken: TMenuItem;
    MainMenu_Datei_DruckerEinrichten: TMenuItem;
    N6: TMenuItem;
    MainMenu_Datei_Beenden: TMenuItem;
    MainMenu_Bearbeiten: TMenuItem;
    MainMenu_Bearbeiten_Rueckgaengig: TMenuItem;
    MainMenu_Bearbeiten_Wiederherstellen: TMenuItem;
    H4: TMenuItem;
    MainMenu_Bearbeiten_Ausschneiden: TMenuItem;
    MainMenu_Bearbeiten_Kopieren: TMenuItem;
    MainMenu_Bearbeiten_Einfuegen: TMenuItem;
    MainMenu_Bearbeiten_Loeschen: TMenuItem;
    N2: TMenuItem;
    MainMenu_Markierung: TMenuItem;
    MainMenu_Markierung_InGrobuchstabenUmwandeln: TMenuItem;
    MainMenu_Markierung_InKleinbuchstabenUmwandeln: TMenuItem;
    N8: TMenuItem;
    MainMenu_Markierung_NichtsMarkieren: TMenuItem;
    MainMenu_Markierung_AllesMarkieren: TMenuItem;
    MainMenu_Suchen: TMenuItem;
    MainMenu_Suchen_Suchen: TMenuItem;
    PrintDialog: TPrintDialog;
    PrinterSetupDialog: TPrinterSetupDialog;
    FindDialog: TFindDialog;
    N7: TMenuItem;
    MainMenu_Datei_Statistik: TMenuItem;
    MainMenu_Bearbeiten_ZeilenUmbrechen: TMenuItem;
    MainMenu_Suchen_Weitersuchen: TMenuItem;
    MainMenu_Bearbeiten_NurLesenZulassen: TMenuItem;
    N3: TMenuItem;
    MainMenu_Bearbeiten_DatumUhrzeitEinfuegen: TMenuItem;
    MainMenu_Bearbeiten_DateinameEinfuegen: TMenuItem;
    // Formular
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OnCreate(Sender: TObject);
    procedure OnShow(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure OnResize(Sender: TObject);
    // RichEdit
    procedure RichEdit_OnChange(Sender: TObject);
    procedure RichEdit_OnSelectionChange(Sender: TObject);
    procedure RichEdit_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure RichEdit_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RichEdit_OnUrlClick(Sender: TObject; URL: String);
    procedure PopupMenu_OnPopup(Sender: TObject);
    // MainMenu
    procedure MainMenu_Datei_Neu_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Oeffnen_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Speichern_OnClick(Sender: TObject);
    procedure MainMenu_Datei_SpeichernUnter_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Schliessen_OnClick(Sender: TObject);
    procedure MainMenu_Datei_AlleSchliessen_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Drucken_OnClick(Sender: TObject);
    procedure MainMenu_Datei_DruckerEinrichten_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Statistik_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Beenden_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Rueckgaengig_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Wiederherstellen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Ausschneiden_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Kopieren_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Einfuegen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_Loeschen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_DatumUhrzeitEinfuegen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_DateinameEinfuegen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_NurLesenZulassen_OnClick(Sender: TObject);
    procedure MainMenu_Bearbeiten_ZeilenUmbrechen_OnClick(Sender: TObject);
    procedure MainMenu_Markierung_InGrobuchstabenUmwandeln_OnClick(Sender: TObject);
    procedure MainMenu_Markierung_InKleinbuchstabenUmwandeln_OnClick(Sender: TObject);
    procedure MainMenu_Markierung_NichtsMarkieren_OnClick(Sender: TObject);
    procedure MainMenu_Markierung_AllesMarkieren_OnClick(Sender: TObject);
    procedure MainMenu_Suchen_Suchen_OnClick(Sender: TObject);
    procedure MainMenu_Suchen_Weitersuchen_OnClick(Sender: TObject);
  public
    // Public-Deklarationen
    procedure SetEnDisAbledState(StateNr: byte);
    procedure SetColLinePosInStatusBar;
    function SaveTextToFile(TextFileStr: string): boolean;
    function SaveTextToFileWithBrowse(TextFileStr: string): boolean;
    function FindBrowser: string;
    function BrowserPath: string;
  end;

Var
  MainChildForm: TMainChildForm;

IMPLEMENTATION

Uses Main, Statistk;

{$R *.DFM}

{-------------------------------------------------------------------------------
Formular
-------------------------------------------------------------------------------}

procedure TMainChildForm.OnClose(Sender: TObject; var Action: TCloseAction);
var i1: integer; deltab: TTabsheet;
begin
  Action:=caFree;
  For i1:=0 to Mainform.PageCtrl.PageCount-1 do If MainForm.PageCtrl.Pages[i1].Tag=(Sender as TForm).Tag then DelTab:=MainForm.PageCtrl.Pages[i1];
  DelTab.Destroy;
end;

procedure TMainChildForm.OnCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=false;
  If RichEdit.Modified then begin
    Case MessageBox(0,PChar('Datei "'+Caption+'" wurde modifiziert.'+#13+'Sollen die nderungen gespeichert werden ?'),'nderungen speichern ?',MB_IconQuestion+MB_YesNoCancel+MB_SetForeground+MB_ApplModal) of
      idYes: If FileExists(Caption) then begin If not SaveTextToFile(Caption) then Exit; end
             else begin If not SaveTextToFileWithBrowse(Caption) then Exit; end;
      idCancel: Exit;
    end;
  end;
  With MainForm do If MDIChildCount<2 then begin
    MainMenu_Fenster.Visible:=false;
    SetEnDisAbledState(11); Button_Drucken.Enabled:=false;
    Button_Rueckgaengig.Enabled:=false; Button_Wiederherstellen.Enabled:=false;
    Button_Ausschneiden.Enabled:=false; Button_Kopieren.Enabled:=false; Button_Einfuegen.Enabled:=false; Button_Loeschen.Enabled:=false;
    Button_Grossbuchstaben.Enabled:=false; Button_Kleinbuchstaben.Enabled:=false; Button_NichtsMarkieren.Enabled:=false; Button_AllesMarkieren.Enabled:=false;
    Button_Suchen.Enabled:=false; Button_Weitersuchen.Enabled:=false;
    Button_Laengsteilen.Enabled:=false; Button_Querteilen.Enabled:=false; Button_Ueberlappen.Enabled:=false;
    PageCtrl.Visible:=false;
  end;
  CanClose:=true;
end;

procedure TMainChildForm.OnCreate(Sender: TObject);
begin
  RichEdit.ShowSelectionBar:=ShowMarkLeiste;
  If not UseAutoUrls then RichEdit.AutoUrlDetect:=adNone;
  If MainForm.MDIChildCount>0 then With MainForm do begin MainMenu_Fenster.Visible:=true;
    Button_Drucken.Enabled:=true; Button_Einfuegen.Enabled:=true;
    Button_NichtsMarkieren.Enabled:=true; Button_AllesMarkieren.Enabled:=true;
    Button_Suchen.Enabled:=true; Button_Weitersuchen.Enabled:=true;
    Button_Laengsteilen.Enabled:=true; Button_Querteilen.Enabled:=true; Button_Ueberlappen.Enabled:=true;
    PageCtrl.Visible:=true;
  end;
end;

procedure TMainChildForm.OnShow(Sender: TObject);
begin If not RichEdit.Modified then SetEnDisAbledState(11); OnResize(Sender); end;

procedure TMainChildForm.OnActivate(Sender: TObject);
var i1: integer;
begin
  If RichEdit.Modified then SetEnDisAbledState(10) else SetEnDisAbledState(11);
  If (MainForm.PageCtrl.ActivePage<>nil)and(Tag<>MainForm.PageCtrl.ActivePage.Tag) then
    For i1:=0 to MainForm.PageCtrl.PageCount-1 do If Tag=MainForm.PageCtrl.Pages[i1].Tag then MainForm.PageCtrl.ActivePage:=MainForm.PageCtrl.Pages[i1];  
  RichEdit_OnSelectionChange(Sender);
end;

procedure TMainChildForm.OnResize(Sender: TObject);
var OR_Int1: integer;
begin StatusBar.Panels[0].Width:=StatusBar.Width-290; end;

{-------------------------------------------------------------------------------
RichEdit
-------------------------------------------------------------------------------}

procedure TMainChildForm.RichEdit_OnChange(Sender: TObject);
begin
  If RichEdit.Modified then SetEnDisAbledState(10) else SetEnDisAbledState(11); SetColLinePosInStatusBar;
  If RichEdit.ReadOnly then SetEnDisAbledState(20) else begin
    MainMenu_Bearbeiten_Rueckgaengig.Enabled:=RichEdit.CanUndo; MainForm.Button_Rueckgaengig.Enabled:=MainMenu_Bearbeiten_Rueckgaengig.Enabled;
    MainMenu_Bearbeiten_Wiederherstellen.Enabled:=RichEdit.CanRedo; MainForm.Button_Wiederherstellen.Enabled:=MainMenu_Bearbeiten_Wiederherstellen.Enabled;
  end;
end;

procedure TMainChildForm.RichEdit_OnSelectionChange(Sender: TObject);
begin
  StatusBar.Panels[0].Text:=IntToStr(RichEdit.SelLength)+' Zeichen markiert.'; SetColLinePosInStatusBar;
  If RichEdit.ReadOnly then SetEnDisAbledState(20) else begin
    MainMenu_Markierung_InGrobuchstabenUmwandeln.Enabled:=RichEdit.SelLength>0; MainForm.Button_Grossbuchstaben.Enabled:=MainMenu_Markierung_InGrobuchstabenUmwandeln.Enabled;
    MainMenu_Markierung_InKleinbuchstabenUmwandeln.Enabled:=RichEdit.SelLength>0; MainForm.Button_Kleinbuchstaben.Enabled:=MainMenu_Markierung_InKleinbuchstabenUmwandeln.Enabled;
    MainMenu_Bearbeiten_Ausschneiden.Enabled:=RichEdit.SelLength>0; MainForm.Button_Ausschneiden.Enabled:=MainMenu_Bearbeiten_Ausschneiden.Enabled;
    MainMenu_Bearbeiten_Kopieren.Enabled:=RichEdit.SelLength>0; MainForm.Button_Kopieren.Enabled:=MainMenu_Bearbeiten_Kopieren.Enabled;
    MainMenu_Bearbeiten_Loeschen.Enabled:=RichEdit.SelLength>0; MainForm.Button_Loeschen.Enabled:=MainMenu_Bearbeiten_Loeschen.Enabled;
  end;
end;

procedure TMainChildForm.RichEdit_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  SetColLinePosInStatusBar;
  Case Key of
    45: If Shift=[] then begin // "Einfg."
          If StatusBar.Panels[2].Text='Einfg.' then StatusBar.Panels[2].Text:='berschr.' else StatusBar.Panels[2].Text:='Einfg.';
        end;
  end;
end;

procedure TMainChildForm.RichEdit_OnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin SetColLinePosInStatusBar; end;

procedure TMainChildForm.RichEdit_OnUrlClick(Sender: TObject; URL: String);
var REOUC_Str1, REOUC_Str2: string;
begin
  REOUC_Str1:=BrowserPath; REOUC_Str2:=Url;
  If REOUC_Str1='' then begin
    If MessageBox(0,'In ihrem System konnte kein Web-Browser gefunden werden.'+#13+'Denoch versuchen die Url auszufhren ?','Fehler: Browser nicht gefunden...',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)<>idOk then Exit;
    REOUC_Str1:=REOUC_Str2; REOUC_Str2:='';
  end;
  ExecuteFile(REOUC_Str1,REOUC_Str2);
end;

procedure TMainChildForm.PopupMenu_OnPopup(Sender: TObject);
begin
  PopupMenu_Rueckgaengig.Enabled:=RichEdit.CanUndo; PopupMenu_Ausschneiden.Enabled:=RichEdit.SelLength>0;
  PopupMenu_Kopieren.Enabled:=RichEdit.SelLength>0; PopupMenu_Einfuegen.Enabled:=Clipboard.HasFormat(CF_TEXT);
  PopupMenu_Loeschen.Enabled:=RichEdit.SelLength>0;
end;

{-------------------------------------------------------------------------------
MainMenu
-------------------------------------------------------------------------------}

procedure TMainChildForm.MainMenu_Datei_Neu_OnClick(Sender: TObject);
begin MainForm.MainMenu_Datei_Neu_OnClick(Sender); end;

procedure TMainChildForm.MainMenu_Datei_Oeffnen_OnClick(Sender: TObject);
begin MainForm.MainMenu_Datei_Oeffnen_OnClick(Sender); end;

procedure TMainChildForm.MainMenu_Datei_Speichern_OnClick(Sender: TObject);
begin If FileExists(Caption) then SaveTextToFile(Caption) else MainMenu_Datei_SpeichernUnter_OnClick(Sender); end;

procedure TMainChildForm.MainMenu_Datei_SpeichernUnter_OnClick(Sender: TObject);
begin SaveTextToFileWithBrowse(Caption); end;

procedure TMainChildForm.MainMenu_Datei_Schliessen_OnClick(Sender: TObject);
begin Close; end;

procedure TMainChildForm.MainMenu_Datei_AlleSchliessen_OnClick(Sender: TObject);
var i1: integer;
begin For i1:=MainForm.MDIChildCount-1 downto 0 do Try MainForm.MDIChildren[i1].Close; Finally MainForm.MDIChildren[i1].Free; end; end;

procedure TMainChildForm.MainMenu_Datei_Drucken_OnClick(Sender: TObject);
var MDD_Int1: integer;
begin With PrintDialog do If Execute then For MDD_Int1:=1 to Copies do RichEdit.Print(IntToStr(MDD_Int1)+' - '+Caption); end;

procedure TMainChildForm.MainMenu_Datei_DruckerEinrichten_OnClick(Sender: TObject);
begin PrinterSetupDialog.Execute; end;

procedure TMainChildForm.MainMenu_Datei_Statistik_OnClick(Sender: TObject);
begin With TStatistikForm.Create(Self) do Try ShowModal; Finally Free; end; end;

procedure TMainChildForm.MainMenu_Datei_Beenden_OnClick(Sender: TObject);
begin Try Close; finally MainForm.MainMenu_Datei_Beenden_OnClick(Sender); end; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Rueckgaengig_OnClick(Sender: TObject);
begin RichEdit.Undo; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Wiederherstellen_OnClick(Sender: TObject);
begin RichEdit.Redo; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Ausschneiden_OnClick(Sender: TObject);
begin RichEdit.CutToClipboard; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Kopieren_OnClick(Sender: TObject);
begin RichEdit.CopyToClipboard; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Einfuegen_OnClick(Sender: TObject);
begin RichEdit.PasteFromClipboard; end;

procedure TMainChildForm.MainMenu_Bearbeiten_Loeschen_OnClick(Sender: TObject);
begin RichEdit.ClearSelection; end;

procedure TMainChildForm.MainMenu_Bearbeiten_DatumUhrzeitEinfuegen_OnClick(Sender: TObject);
begin RichEdit.Lines.Insert(RichEdit.Line,DateTimeToStr(Time)); end;

procedure TMainChildForm.MainMenu_Bearbeiten_DateinameEinfuegen_OnClick(Sender: TObject);
begin RichEdit.Lines.Insert(RichEdit.Line,Caption); end;

procedure TMainChildForm.MainMenu_Bearbeiten_NurLesenZulassen_OnClick(Sender: TObject);
begin
  If RichEdit.ReadOnly then begin
    RichEdit.ReadOnly:=false; MainMenu_Bearbeiten_NurLesenZulassen.Checked:=false; RichEdit_OnChange(Sender); RichEdit_OnSelectionChange(Sender);
    MainMenu_Bearbeiten_Einfuegen.Enabled:=true; MainForm.Button_Einfuegen.Enabled:=true;
  end else begin RichEdit.ReadOnly:=true; MainMenu_Bearbeiten_NurLesenZulassen.Checked:=true; SetEnDisAbledState(20); end;
end;

procedure TMainChildForm.MainMenu_Bearbeiten_ZeilenUmbrechen_OnClick(Sender: TObject);
begin
  If RichEdit.WordWrap then begin RichEdit.ScrollBars:=ssBoth; RichEdit.WordWrap:=false; MainMenu_Bearbeiten_ZeilenUmbrechen.Checked:=false; end
  else begin RichEdit.ScrollBars:=ssVertical; RichEdit.WordWrap:=true; MainMenu_Bearbeiten_ZeilenUmbrechen.Checked:=true; end;
  RichEdit_OnChange(Sender);
end;

procedure TMainChildForm.MainMenu_Markierung_InGrobuchstabenUmwandeln_OnClick(Sender: TObject);
var MMIGU_Int1: integer; MMIGU_Str1: string;
begin With RichEdit do begin MMIGU_Str1:=SelText; MMIGU_Int1:=SelStart; SelText:=UpperCase(MMIGU_Str1); SelStart:=MMIGU_Int1; SelLength:=Length(MMIGU_Str1); end; end;

procedure TMainChildForm.MainMenu_Markierung_InKleinbuchstabenUmwandeln_OnClick(Sender: TObject);
var MMIKU_Int1: integer; MMIKU_Str1: string;
begin With RichEdit do begin MMIKU_Str1:=SelText; MMIKU_Int1:=SelStart; SelText:=LowerCase(MMIKU_Str1); SelStart:=MMIKU_Int1; SelLength:=Length(MMIKU_Str1); end; end;

procedure TMainChildForm.MainMenu_Markierung_NichtsMarkieren_OnClick(Sender: TObject);
begin RichEdit.SelLength:=0; end;

procedure TMainChildForm.MainMenu_Markierung_AllesMarkieren_OnClick(Sender: TObject);
begin RichEdit.SelectAll; end;

procedure TMainChildForm.MainMenu_Suchen_Suchen_OnClick(Sender: TObject);
begin FindDialog.Execute; end;

procedure TMainChildForm.MainMenu_Suchen_Weitersuchen_OnClick(Sender: TObject);
var FndSpalte, FndZeile, Fnd_Int1, Fnd_Int2, Fnd_Int3: integer; Fnd_Str1, Fnd_Str2: string;
  function IsEndeErreicht: boolean;
  begin
    With RichEdit do
      If FndZeile<Lines.Count-1 then begin inc(FndZeile); FndSpalte:=0; Result:=false; end else begin
        If MessageBox(0,'Das Ende der Textdatei wurde erreicht.'+#13+'Suche von vorne beginnen ?','Suche abgeschloen...',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)=idOk then begin
          Col:=0; Line:=0; MainMenu_Suchen_Weitersuchen_OnClick(Sender);
        end else FindDialog.CloseDialog;
        Result:=true;
      end;
  end;
begin
  If FindDialog.FindText>'' then begin With RichEdit do begin
    FndSpalte:=Col; If FndSpalte<0 then FndSpalte:=0; FndZeile:=Line; If FndZeile<0 then FndZeile:=0;
    If SelLength>0 then begin
      If FndSpalte<Length(Lines[FndZeile])-1 then inc(FndSpalte) else If IsEndeErreicht then Exit; end;
    Fnd_Str1:=FindDialog.FindText; If not(frMatchCase in FindDialog.Options) then Fnd_Str1:=UpperCase(Fnd_Str1);
    Repeat
      Fnd_Str2:=Lines[FndZeile]; Delete(Fnd_Str2,1,FndSpalte); If not(frMatchCase in FindDialog.Options) then Fnd_Str2:=UpperCase(Fnd_Str2);
      Fnd_Int1:=Pos(Fnd_Str1,Fnd_Str2);
      If Fnd_Int1>0 then begin
        Fnd_Int3:=0; For Fnd_Int2:=0 to FndZeile-1 do Fnd_Int3:=Fnd_Int3+Length(Lines[Fnd_Int2])+1;
        Update; SetFocus; SelStart:=Fnd_Int3+FndSpalte+Fnd_Int1-1; SelLength:=Length(Fnd_Str1);
        Exit;        
      end else If IsEndeErreicht then Exit;
    until false;
  end; end else MainMenu_Suchen_Suchen_OnClick(Sender);
end;

{-------------------------------------------------------------------------------
Public-Deklarationen
-------------------------------------------------------------------------------}

procedure TMainChildForm.SetEnDisAbledState(StateNr: byte);
begin
  Case StateNr of
    10: If not MainForm.Button_Speichern.Enabled then begin // Text wurde gendert
          MainForm.Button_Speichern.Enabled:=true;
          MainMenu_Datei_Speichern.Enabled:=true;
          StatusBar.Panels[1].Text:='Modifiziert';
        end;
    11: If MainForm.Button_Speichern.Enabled then begin // Text wurde nicht gendert
          MainForm.Button_Speichern.Enabled:=false;
          MainMenu_Datei_Speichern.Enabled:=false;
          StatusBar.Panels[1].Text:='Gesichert';
        end;
    20: begin // Datei ist zum bearbeiten gesperrt: "Nur lesen zulassen"
          MainMenu_Markierung_InGrobuchstabenUmwandeln.Enabled:=false; MainForm.Button_Grossbuchstaben.Enabled:=false;
          MainMenu_Markierung_InKleinbuchstabenUmwandeln.Enabled:=false; MainForm.Button_Kleinbuchstaben.Enabled:=false;
          MainMenu_Bearbeiten_Rueckgaengig.Enabled:=false; MainForm.Button_Rueckgaengig.Enabled:=false;
          MainMenu_Bearbeiten_Wiederherstellen.Enabled:=false; MainForm.Button_Wiederherstellen.Enabled:=false;
          MainMenu_Bearbeiten_Ausschneiden.Enabled:=false; MainForm.Button_Ausschneiden.Enabled:=false;
          MainMenu_Bearbeiten_Kopieren.Enabled:=false; MainForm.Button_Kopieren.Enabled:=false;
          MainMenu_Bearbeiten_Einfuegen.Enabled:=false; MainForm.Button_Einfuegen.Enabled:=false;
          MainMenu_Bearbeiten_Loeschen.Enabled:=false; MainForm.Button_Loeschen.Enabled:=false;
          PopupMenu_Rueckgaengig.Enabled:=false; PopupMenu_Ausschneiden.Enabled:=false;
          PopupMenu_Kopieren.Enabled:=false; PopupMenu_Einfuegen.Enabled:=false; PopupMenu_Loeschen.Enabled:=false;
        end;
  end;
end;

procedure TMainChildForm.SetColLinePosInStatusBar;
begin
  With RichEdit do begin If (Col>=0)and(Line>=0) then StatusBar.Panels[3].Text:=IntToStr(Col+1)+':'+IntToStr(Line+1);
    {If Line>0 then StatusBar.Panels[3].Text:=IntToStr(GetProcent(Lines.Count,Line))+'%';} end;
end;

function TMainChildForm.SaveTextToFile(TextFileStr: string): boolean;
var ST_Str1: string; ST_File: textfile;
begin
  Result:=false;
  If FileExists(TextFileStr) then If FileIsReadOnly(TextFileStr) then // Bereits existierende Datei ist schreibgeschtzt
    Case MessageBox(0,PChar('Die angegebene Datei "'+TextFileStr+'" ist schreibgeschtzt.'+#13+'Dateiattribut entfernen und dann berschreiben ?'),'Datei ist schreibgeschtzt...',MB_IconQuestion+MB_YesNoCancel+MB_SetForeground+MB_ApplModal) of
      idYes: If FileSetAttr(TextFileStr,FileGetAttr(TextFileStr)-faReadOnly)<>0 then begin
               MessageBox(0,'Das Dateiattribut Schreibgeschtzt konnte nicht entfernt werden.'+#13+'Speichervorgang wird abgebrochen.','Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
               Exit;
             end;
      idNo: begin If SaveTextToFileWithBrowse(TextFileStr) then Result:=true; Exit; end;
      else Exit;
    end;
  // Datei speichern
  Try Screen.Cursor:=crHourGlass; StatusBar.SimpleText:='Datei wird gespeichert...'; StatusBar.SimplePanel:=true;
    AssignFile(ST_File,TextFileStr); {$I-} Rewrite(ST_File); {$I+}
    If IoResult<>0 then begin
      If FileExists(TextFileStr) then ST_Str1:='In Datei "'+TextFileStr+'" konnte nicht geschrieben werden.'
      else ST_Str1:='Die Datei "'+TextFileStr+'" konnte nicht erstellt werden.';
      MessageBox(0,PChar(ST_Str1),'Fehler: Speichern fehlgeschlagen...',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
    end else Result:=true;
    {$I-} CloseFile(ST_File); {$I+}
    If (IoResult<>0)and(Result) then begin Result:=false;
      MessageBox(0,PChar('Der Text konnte nicht in "'+TextFileStr+'" gespeichert werden.'),'Fehler: Speichern fehlgeschlagen...',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
    end else Try RichEdit.Lines.SaveToFile(TextFileStr);
      Finally RichEdit.Modified:=false; SetEnDisAbledState(11); If Caption<>TextFileStr then Caption:=TextFileStr; end;
  Finally StatusBar.SimplePanel:=false; Screen.Cursor:=crDefault; end;
end;

function TMainChildForm.SaveTextToFileWithBrowse(TextFileStr: string): boolean;
var STTF_Str1: string;
begin
  With MainForm.SaveDialog do begin STTF_Str1:=ExtractFilePath(TextFileStr);
    If DirectoryExists(STTF_Str1) then begin InitialDir:=STTF_Str1; Filename:=ExtractFileName(TextFileStr); end;
    If Execute then Result:=SaveTextToFile(ExpandFileName(Filename)) else Result:=false;
  end;
end;

// Der Quellcode der folgenden beiden Routine stammt aus der Freeware-Komponente GotoWeb 2.1
// von CRESTO Sylvain (cresto@mygale.org, http://www.mygale.org/~cresto/) - thanks CRESTO !
function TMainChildForm.FindBrowser: string;
var c: byte; hkey1,hkey2: hkey; typ,taille: integer; tmp: array[0..1024] of char;
const nbr_extension=4; extension: array[0..nbr_extension-1] of string=('.HTM','.HTML','.SHTML','.SHTM');
begin
  c:=0;
  Repeat
    if regopenkeyex(hkey_classes_root,pchar(extension[c]),0,key_all_access,hkey1)=0 then begin
      if regqueryvalueex(hkey1,nil,nil,@typ,nil,@taille)=error_success then begin
        regqueryvalueex(hkey1,nil,nil,nil,@tmp,@taille);
        if tmp<>'' then
          if regopenkeyex(hkey_classes_root,pchar(tmp+'\shell\open\command'),0,key_all_access,hkey2)=error_success then begin
            if regqueryvalueex(hkey2,nil,nil,@typ,nil,@taille)=error_success then begin regqueryvalueex(hkey2,nil,nil,nil,@tmp,@taille);
              if tmp<>'' then begin RegCloseKey(hkey2); FindBrowser:=strpas(tmp); Exit; end; end;
            regclosekey(hkey2);
          end;
        if regopenkeyex(hkey1,'shell\open\command',0,key_all_access,hkey2)=error_success then begin
          if regqueryvalueex(hkey2,nil,nil,@typ,nil,@taille)=error_success then begin regqueryvalueex(hkey2,nil,nil,nil,@tmp,@taille);
            if tmp<>'' then begin RegCloseKey(hkey2); FindBrowser:=strpas(tmp); Exit; end; end;
        end;
      end; regclosekey(hkey1);
    end; inc(c);
  until c=nbr_extension;
  FindBrowser:='';
end;

function TMainChildForm.BrowserPath: string;
var tmp, para: string; s,c: word;
begin
  tmp:=findbrowser;
  if tmp<>'' then begin c:=length(tmp)+1;
    repeat dec(c); para:=uppercase(copy(tmp,c-3,4)); until (para='.EXE') or (para='.BAT') or (para='.COM');
    if c<length(tmp) then begin s:=c; para:=trim(copy(tmp,c+1,length(tmp)-(c))); c:=1;
      while (c<=length(para)) do if para[c]='"' then delete(para,c,1) else inc(c);
      if para<>'' then begin c:=1;
        while c<=length(para) do begin
          if para[c]='%' then begin while (c<=length(para)) and (para[c]<>' ') do delete(para,c,1); end else inc(c); end;
      end;
      para:=trim(para); delete(tmp,s+1,length(tmp)-s);
    end else para:='';
    if tmp[1]='"' then delete(tmp,1,1);
  end;
  BrowserPath:=tmp;
end;

END.
